require "net/http"
require "uri"
require "json"

module Request
    class Http
        def self.send_request(method, url, body = nil, headers = nil)
            methods = { "get" => Net::HTTP::Get, "post" => Net::HTTP::Post, "delete" => Net::HTTP::Delete, "put" => Net::HTTP::Put }
            uri = URI.parse(url)
            http = Net::HTTP.new(uri.host, uri.port)
            http.use_ssl = (uri.scheme == "https")
            request = methods[method].new(uri.request_uri)
            request["User-Agent"] = "zyxt tool"
            request["Accept"] = "*/*"
            request["Content-Type"] = "application/json"
            if !headers.nil?
                headers.each do | key, value |
                    request[key] = value
                end
            end
            if !body.nil?
                request.body = body.to_json
            end
            response = http.request(request)
        end

        def self.log(response)
            puts "Status Code: #{response.code}"
            puts "Body: #{response.body}"
        end
    end
end
